fix(bklog):Add missing function timeDuration() from bkgpslog
authorSteven Baltakatei Sandoval <baltakatei@gmail.com>
Sat, 11 Jul 2020 01:19:19 +0000 (01:19 +0000)
committerSteven Baltakatei Sandoval <baltakatei@gmail.com>
Sat, 11 Jul 2020 01:19:19 +0000 (01:19 +0000)
Rearrange function declarations

exec/bklog

index 1f561db0ae72ef7cd10595c8dbb8acd0a5f93396..3d25fe312a70dcd175fe1b7c9e0de71ed8f1a548 100644 (file)
@@ -413,6 +413,380 @@ appendFileTar(){
     try tar --append --directory="$tmpDir" --file="$tarPath" "$fileName";
     #yell "DEBUG:STATUS:$fn:Finished appendFileTar()."
 } # Append [processed] file to Tar archive
+timeDuration(){
+    # Desc: Given seconds, output ISO-8601 duration string
+    # Ref/Attrib: ISO-8601:2004(E), §4.4.4.2 Representations of time intervals by duration and context information
+    # Note: "1 month" ("P1M") is assumed to be "30 days" (see ISO-8601:2004(E), §2.2.1.2)
+    # Usage: timeDuration [1:seconds] ([2:precision])
+    # Version: 1.0.4
+    # Input: arg1: seconds as base 10 integer >= 0  (ex: 3601)
+    #        arg2: precision level (optional; default=2)
+    # Output: stdout: ISO-8601 duration string (ex: "P1H1S", "P2Y10M15DT10H30M20S")
+    #         exit code 0: success
+    #         exit code 1: error_input
+    #         exit code 2: error_unknown
+    # Example: 'timeDuration 111111 3' yields 'P1DT6H51M'
+    # Depends: date 8, bash 5, yell,
+    local argSeconds argPrecision precision returnState remainder
+    local fullYears fullMonths fullDays fullHours fullMinutes fullSeconds
+    local hasYears hasMonths hasDays hasHours hasMinutes hasSeconds
+    local witherPrecision output
+    local displayYears displayMonths displayDays displayHours displayMinutes displaySeconds
+    
+    argSeconds="$1"; # read arg1 (seconds)
+    argPrecision="$2"; # read arg2 (precision)
+    precision=2; # set default precision
+
+    # Check that between one and two arguments is supplied
+    if ! { [[ $# -ge 1 ]] && [[ $# -le 2 ]]; }; then
+       yell "ERROR:Invalid number of arguments:$# . Exiting.";
+       returnState="error_input"; fi
+
+    # Check that argSeconds provided
+    if [[ $# -ge 1 ]]; then
+       ## Check that argSeconds is a positive integer
+       if [[ "$argSeconds" =~ ^[[:digit:]]+$ ]]; then
+           :
+       else
+           yell "ERROR:argSeconds not a digit.";
+           returnState="error_input";
+       fi
+    else
+       yell "ERROR:No argument provided. Exiting.";
+       exit 1;
+    fi
+
+    # Consider whether argPrecision was provided
+    if  [[ $# -eq 2 ]]; then
+       # Check that argPrecision is a positive integer
+       if [[ "$argPrecision" =~ ^[[:digit:]]+$ ]] && [[ "$argPrecision" -gt 0 ]]; then
+       precision="$argPrecision";
+       else
+           yell "ERROR:argPrecision not a positive integer. (is $argPrecision ). Leaving early.";
+           returnState="error_input";
+       fi;
+    else
+       :
+    fi;
+    
+    remainder="$argSeconds" ; # seconds
+    ## Calculate full years Y, update remainder
+    fullYears=$(( remainder / (365*24*60*60) ));
+    remainder=$(( remainder - (fullYears*365*24*60*60) ));
+    ## Calculate full months M, update remainder
+    fullMonths=$(( remainder / (30*24*60*60) ));
+    remainder=$(( remainder - (fullMonths*30*24*60*60) ));
+    ## Calculate full days D, update remainder
+    fullDays=$(( remainder / (24*60*60) ));
+    remainder=$(( remainder - (fullDays*24*60*60) ));
+    ## Calculate full hours H, update remainder
+    fullHours=$(( remainder / (60*60) ));
+    remainder=$(( remainder - (fullHours*60*60) ));
+    ## Calculate full minutes M, update remainder
+    fullMinutes=$(( remainder / (60) ));
+    remainder=$(( remainder - (fullMinutes*60) ));
+    ## Calculate full seconds S, update remainder
+    fullSeconds=$(( remainder / (1) ));
+    remainder=$(( remainder - (remainder*1) ));
+    ## Check which fields filled
+    if [[ $fullYears -gt 0 ]]; then hasYears="true"; else hasYears="false"; fi
+    if [[ $fullMonths -gt 0 ]]; then hasMonths="true"; else hasMonths="false"; fi
+    if [[ $fullDays -gt 0 ]]; then hasDays="true"; else hasDays="false"; fi
+    if [[ $fullHours -gt 0 ]]; then hasHours="true"; else hasHours="false"; fi
+    if [[ $fullMinutes -gt 0 ]]; then hasMinutes="true"; else hasMinutes="false"; fi
+    if [[ $fullSeconds -gt 0 ]]; then hasSeconds="true"; else hasSeconds="false"; fi
+    
+    ## Determine which fields to display (see ISO-8601:2004 §4.4.3.2)
+    witherPrecision="false"
+    
+    ### Years
+    if $hasYears && [[ $precision -gt 0 ]]; then
+       displayYears="true";
+       witherPrecision="true";
+    else
+       displayYears="false";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+    
+    ### Months
+    if $hasMonths && [[ $precision -gt 0 ]]; then
+       displayMonths="true";
+       witherPrecision="true";
+    else
+       displayMonths="false";
+    fi;
+    if $witherPrecision && [[ $precision -gt 0 ]]; then
+       displayMonths="true";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+
+    ### Days
+    if $hasDays && [[ $precision -gt 0 ]]; then
+       displayDays="true";
+       witherPrecision="true";
+    else
+       displayDays="false";
+    fi;
+    if $witherPrecision && [[ $precision -gt 0 ]]; then
+       displayDays="true";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+
+    ### Hours
+    if $hasHours && [[ $precision -gt 0 ]]; then
+       displayHours="true";
+       witherPrecision="true";
+    else
+       displayHours="false";
+    fi;
+    if $witherPrecision && [[ $precision -gt 0 ]]; then
+       displayHours="true";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+
+    ### Minutes
+    if $hasMinutes && [[ $precision -gt 0 ]]; then
+       displayMinutes="true";
+       witherPrecision="true";
+    else
+       displayMinutes="false";
+    fi;
+    if $witherPrecision && [[ $precision -gt 0 ]]; then
+       displayMinutes="true";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+
+    ### Seconds
+
+    if $hasSeconds && [[ $precision -gt 0 ]]; then
+       displaySeconds="true";
+       witherPrecision="true";
+    else
+       displaySeconds="false";
+    fi;
+    if $witherPrecision && [[ $precision -gt 0 ]]; then
+       displaySeconds="true";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+
+    ## Determine whether or not the "T" separator is needed to separate date and time elements
+    if ( $displayHours || $displayMinutes || $displaySeconds); then
+       displayDateTime="true"; else displayDateTime="false"; fi
+    
+    ## Construct duration output string
+    output="P"
+    if $displayYears; then
+       output=$output$fullYears"Y"; fi
+    if $displayMonths; then
+       output=$output$fullMonths"M"; fi
+    if $displayDays; then
+       output=$output$fullDays"D"; fi
+    if $displayDateTime; then
+       output=$output"T"; fi
+    if $displayHours; then
+       output=$output$fullHours"H"; fi
+    if $displayMinutes; then
+       output=$output$fullMinutes"M"; fi
+    if $displaySeconds; then
+       output=$output$fullSeconds"S"; fi
+
+    ## Output duration string to stdout
+    echo "$output" && returnState="true";
+
+    #===Determine function return code===
+    if [ "$returnState" = "true" ]; then
+       return 0;
+    elif [ "$returnState" = "error_input" ]; then
+       yell "ERROR:input";
+       return 1;
+    else
+       yell "ERROR:Unknown";
+       return 2;
+    fi
+
+} # Get duration (ex: PT10M4S )
+magicInitWorkingDir() {
+    # Desc: Determine temporary working directory from defaults or user input
+    # Usage: magicInitWorkingDir
+    # Input:  vars: optionTmpDir, argTempDirPriority, dirTmpDefault
+    # Input:  vars: scriptTimeStart
+    # Output: vars: dir_tmp
+    # Depends: bash 5.0.3, processArguments(), vbm(), yell()
+    # Parse '-t' option (user-specified temporary working dir)
+    ## Set dir_tmp_parent to user-specified value if specified
+    local dir_tmp_parent
+    
+    if [[ "$optionTmpDir" = "true" ]]; then
+       if [[ -d "$argTempDirPriority" ]]; then
+           dir_tmp_parent="$argTempDirPriority"; 
+       else
+           yell "WARNING:Specified temporary working directory not valid:$argTempDirPriority";
+           exit 1; # Exit since user requires a specific temp dir and it is not available.
+       fi;
+    else
+    ## Set dir_tmp_parent to default or fallback otherwise
+       if [[ -d "$dirTmpDefault" ]]; then
+           dir_tmp_parent="$dirTmpDefault";
+       elif [[ -d /tmp ]]; then
+           yell "WARNING:$dirTmpDefault not available. Falling back to /tmp .";
+           dir_tmp_parent="/tmp";
+       else
+           yell "ERROR:No valid working directory available. Exiting.";
+           exit 1;
+       fi;
+    fi;
+    ## Set dir_tmp using dir_tmp_parent and nonce (scriptTimeStart)
+    dir_tmp="$dir_tmp_parent"/"$scriptTimeStart""..bkgpslog" && vbm "DEBUG:Set dir_tmp to:$dir_tmp"; # Note: removed at end of main().
+} # Sets working dir
+magicInitCheckTar() {
+    # Desc: Initializes or checks output tar
+    # input: vars: dirOut, bufferTTL, cmd_encrypt_suffix, cmd_compress_suffix
+    # input: vars: scriptHostname
+    # output: vars: pathout_tar
+    # depends: Bash 5.0.3, vbm(), dateShort(), checkMakeTar(), magicWriteVersion()
+
+    # Form pathout_tar
+    pathout_tar="$dirOut"/"$(dateShort "$(date --date="$bufferTTL seconds ago" --iso-8601=seconds)")".."$scriptHostname""$label""$cmd_compress_suffix""$cmd_encrypt_suffix".tar && \
+       vbm "STATUS:Set pathout_tar to:$pathout_tar";
+    # Validate pathout_tar as tar.
+    checkMakeTar "$pathout_tar";
+    ## Add VERSION file if checkMakeTar had to create a tar (exited 1) or replace one (exited 2)
+    vbm "exit status before magicWriteVersion:$?"
+    if [[ $? -eq 1 ]] || [[ $? -eq 2 ]]; then magicWriteVersion; fi    
+} # Initialize tar, set pathout_tar
+magicParseCompressionArg() {
+    # Desc: Parses compression arguments specified by '-c' option
+    # Input:  vars: optionCompress
+    # Output: cmd_compress, cmd_compress_suffix
+    # Depends: processArguments(), vbm(), checkapp(), gzip 1.9
+    if [[ "$optionCompress" = "true" ]]; then # Check if compression option active
+       if checkapp gzip; then # Check if gzip available
+           cmd_compress="gzip " && vbm "cmd_compress:$cmd_compress";
+           cmd_compress_suffix=".gz" && vbm "cmd_compress_suffix:$cmd_compress_suffix";
+       else
+           yell "ERROR:Compression enabled but \"gzip\" not found. Exiting."; exit 1;
+       fi
+    else
+       cmd_compress="tee /dev/null " && vbm "cmd_compress:$cmd_compress";
+       cmd_compress_suffix="" && vbm "cmd_compress_suffix:$cmd_compress_suffix";
+       vbm "DEBUG:Compression not enabled.";
+    fi    
+} # Form compression cmd string and filename suffix
+magicParseCustomTTL() {
+    # Desc: Set user-specified TTLs for buffer and script
+    # Usage: magicParseCustomTTL
+    # Input: vars: argCustomBufferTTL (integer), argCustomScriptTTL_TE (string)
+    # Input: vars: optionCustomBufferTTL, optionCustomScriptTTL_TE
+    # Input: vars: bufferTTL (integer), scriptTTL_TE (string)
+    # Output: bufferTTL (integer), scriptTTL_TE (string)
+    # Depends: Bash 5.0.3, yell(), vbm(), validateInput(), showUsage()
+
+    # React to '-b, --buffer-ttl' option
+    if [[ "$optionCustomBufferTTL" = "true" ]]; then
+       ## T: Check if argCustomBufferTTL is an integer
+       if validateInput "$argCustomBufferTTL" "integer"; then
+           ### T: argCustomBufferTTL is an integer
+           bufferTTL="$argCustomBufferTTL" && vbm "Custom bufferTTL from -b:$bufferTTL";
+       else
+           ### F: argcustomBufferTTL is not an integer
+           yell "ERROR:Invalid integer argument for custom buffer time-to-live."; showUsage; exit 1;
+       fi;
+       ## F: do not change bufferTTL
+    fi;
+    
+    # React to '-B, --script-ttl' option
+    if [[ "$optionCustomScriptTTL_TE" = "true" ]]; then
+       ## T: Check if argCustomScriptTTL is a time element (ex: "day", "hour")
+       if validateInput "$argCustomScriptTTL_TE" "time_element"; then
+           ### T: argCustomScriptTTL is a time element
+           scriptTTL_TE="$argCustomScriptTTL_TE" && vbm "Custom scriptTTL_TE from -B:$scriptTTL_TE";
+       else
+           ### F: argcustomScriptTTL is not a time element
+           yell "ERROR:Invalid time element argument for custom script time-to-live."; showUsage; exit 1;
+       fi;
+       ## F: do not change scriptTTL_TE
+    fi;    
+} # Sets custom script or buffer TTL if specified
+magicParseLabel() {
+    # Desc: Parses -l option to set label
+    # In : optionLabel, argLabel
+    # Out: vars: label
+    # Depends: Bash 5.0.3, vbm(), yell()
+    
+    vbm "STATUS:Started magicParseLabel() function.";
+    # Do nothing if optionLabel not set to true.
+    if [[ ! "$optionLabel" = "true" ]]; then
+       vbm "STATUS:optionlabel not set to 'true'. Returning early.";
+       return;
+    fi;
+    # Set label if optionLabel is true
+    if [[ "$optionLabel" = "true" ]]; then
+       label="_""$argLabel";
+       vbm "STATUS:Set label:$label";
+    fi;
+    vbm "STATUS:Finished magicParseLabel() function.";
+} # Set label used in output file name
+magicParseProcessStrings() {
+    # Desc: Processes user-supplied process strings into process commands for appendFileTar().
+    # Usage: magicParseProcessStrings
+    # In : vars: optionProcString optionNoStoreRaw optionStoreRaw argRawFileExt
+    #      arry: argProcStrings, argProcFileExts
+    # Out: arry: procStrings, procFileExts
+    # Depends Bash 5.0.3, yell(), vbm()
+    local rawFileExt
+
+    vbm "STATUS:Starting magicParseProcessStrings() function.";
+    # Validate input
+    ## Validate argRawFileExt
+    if [[ "$argRawFileExt" =~ ^[.][[:alnum:]]*$ ]]; then
+       rawFileExt="$argRawFileExt";
+    fi;
+    
+    # Add default stdin output file entries for procStrings, procFileExts
+    ## Check if user specified that no raw stdin be saved.
+    if [[ ! "$optionNoStoreRaw" = "true" ]]; then
+       ### T: --no-store-raw not set. Store raw. Append procStrings with cat.
+       #### Append procStrings array
+       procStrings+=("cat ");
+       #### Check if --store-raw set.
+       if [[ "$optionStoreRaw" = "true" ]]; then
+           ##### T: --store-raw set. Append procFileExts with user-specified file ext
+           procFileExts+=("$rawFileExt");
+       else
+           ##### F: --store-raw not set. Append procFileExts with default ".stdin" file ext
+           ###### Append procFileExts array
+           procFileExts+=(".stdin");
+       fi;
+    else
+       ### F: --no-store-raw set. Do not store raw.
+       #### Do not append procStrings or procFileExts arrays.
+       :
+    fi;
+
+    # Do nothing more if optionProcString not set to true.
+    if [[ ! "$optionProcString" = "true" ]]; then
+       vbm "STATUS:optionProcString not set to 'true'. Returning early.";
+       return; fi;
+    # Validate input array indices
+    ## Make sure that argProcStrings and argProcFileExts have same index counts
+    if ! [[ "${#argProcStrings[@]}" -eq "${#argProcFileExts[@]}" ]]; then
+       yell "ERROR:Mismatch in number of elements in arrays argProcStrings and argProcFileExts:${#argProcStrings[@]} DNE ${#argProcFileExts[@]}";
+       yell "argProcStrings:${argProcStrings[*]}"; yell "argProcFileExts:${argProcFileExts[*]}"; exit 1; fi;
+    ## Make sure that no array elements are blank
+    for element in "${argProcStrings[@]}"; do
+       if [[ -z "$element" ]]; then yell "ERROR:Empty process string specified. Exiting."; exit 1; fi; done
+    for element in "${argProcFileExts[@]}"; do
+       if [[ -z "$element" ]]; then yell "ERROR:Empty output file extension specified. Exiting."; exit 1; fi; done
+    ## Make sure that no process string starts with '-' (ex: if only one arg supplied after '-p' option)
+    for element in "${argProcStrings[@]}"; do
+       if [[ ! "$element" =~ ^[-][[:print:]]*$ ]] && [[ "$element" =~ ^[[:print:]]*$ ]]; then
+           yell "ERROR:Illegal character '-' at start of process string element. Option syntax error?";
+           exit 1; fi; done;
+    vbm "STATUS:Quick check shows argProcStrings and argProcFileExts appear to have valid contents.";
+    procStrings=("${argProcStrings[@]}"); # Export process command strings
+    procFileExts=("${argProcFileExts[@]}"); # Export process command strings
+    vbm "STATUS:Finished magicParseProcessStrings() function.";
+} # Validate and save process strings and file extensions to arrays procStrings, procFileExts
 magicParseRecipientArgs() {
     # Desc: Parses recipient arguments specified by '-r' option
     # Input:  vars: optionEncrypt, optionRecipients
@@ -506,92 +880,6 @@ magicParseRecipientDir() {
     if [[ ! "$optionEncrypt" = "true" ]] && [[ "$optionRecDir" = "true" ]]; then
        yell "ERROR: \\'-R\\' is set but \\'-e\\' is not set."; fi;
 } # Update recPubKeysValid with argRecDir
-magicParseCompressionArg() {
-    # Desc: Parses compression arguments specified by '-c' option
-    # Input:  vars: optionCompress
-    # Output: cmd_compress, cmd_compress_suffix
-    # Depends: processArguments(), vbm(), checkapp(), gzip 1.9
-    if [[ "$optionCompress" = "true" ]]; then # Check if compression option active
-       if checkapp gzip; then # Check if gzip available
-           cmd_compress="gzip " && vbm "cmd_compress:$cmd_compress";
-           cmd_compress_suffix=".gz" && vbm "cmd_compress_suffix:$cmd_compress_suffix";
-       else
-           yell "ERROR:Compression enabled but \"gzip\" not found. Exiting."; exit 1;
-       fi
-    else
-       cmd_compress="tee /dev/null " && vbm "cmd_compress:$cmd_compress";
-       cmd_compress_suffix="" && vbm "cmd_compress_suffix:$cmd_compress_suffix";
-       vbm "DEBUG:Compression not enabled.";
-    fi    
-} # Form compression cmd string and filename suffix
-magicInitWorkingDir() {
-    # Desc: Determine temporary working directory from defaults or user input
-    # Usage: magicInitWorkingDir
-    # Input:  vars: optionTmpDir, argTempDirPriority, dirTmpDefault
-    # Input:  vars: scriptTimeStart
-    # Output: vars: dir_tmp
-    # Depends: bash 5.0.3, processArguments(), vbm(), yell()
-    # Parse '-t' option (user-specified temporary working dir)
-    ## Set dir_tmp_parent to user-specified value if specified
-    local dir_tmp_parent
-    
-    if [[ "$optionTmpDir" = "true" ]]; then
-       if [[ -d "$argTempDirPriority" ]]; then
-           dir_tmp_parent="$argTempDirPriority"; 
-       else
-           yell "WARNING:Specified temporary working directory not valid:$argTempDirPriority";
-           exit 1; # Exit since user requires a specific temp dir and it is not available.
-       fi;
-    else
-    ## Set dir_tmp_parent to default or fallback otherwise
-       if [[ -d "$dirTmpDefault" ]]; then
-           dir_tmp_parent="$dirTmpDefault";
-       elif [[ -d /tmp ]]; then
-           yell "WARNING:$dirTmpDefault not available. Falling back to /tmp .";
-           dir_tmp_parent="/tmp";
-       else
-           yell "ERROR:No valid working directory available. Exiting.";
-           exit 1;
-       fi;
-    fi;
-    ## Set dir_tmp using dir_tmp_parent and nonce (scriptTimeStart)
-    dir_tmp="$dir_tmp_parent"/"$scriptTimeStart""..bkgpslog" && vbm "DEBUG:Set dir_tmp to:$dir_tmp"; # Note: removed at end of main().
-} # Sets working dir
-magicParseCustomTTL() {
-    # Desc: Set user-specified TTLs for buffer and script
-    # Usage: magicParseCustomTTL
-    # Input: vars: argCustomBufferTTL (integer), argCustomScriptTTL_TE (string)
-    # Input: vars: optionCustomBufferTTL, optionCustomScriptTTL_TE
-    # Input: vars: bufferTTL (integer), scriptTTL_TE (string)
-    # Output: bufferTTL (integer), scriptTTL_TE (string)
-    # Depends: Bash 5.0.3, yell(), vbm(), validateInput(), showUsage()
-
-    # React to '-b, --buffer-ttl' option
-    if [[ "$optionCustomBufferTTL" = "true" ]]; then
-       ## T: Check if argCustomBufferTTL is an integer
-       if validateInput "$argCustomBufferTTL" "integer"; then
-           ### T: argCustomBufferTTL is an integer
-           bufferTTL="$argCustomBufferTTL" && vbm "Custom bufferTTL from -b:$bufferTTL";
-       else
-           ### F: argcustomBufferTTL is not an integer
-           yell "ERROR:Invalid integer argument for custom buffer time-to-live."; showUsage; exit 1;
-       fi;
-       ## F: do not change bufferTTL
-    fi;
-    
-    # React to '-B, --script-ttl' option
-    if [[ "$optionCustomScriptTTL_TE" = "true" ]]; then
-       ## T: Check if argCustomScriptTTL is a time element (ex: "day", "hour")
-       if validateInput "$argCustomScriptTTL_TE" "time_element"; then
-           ### T: argCustomScriptTTL is a time element
-           scriptTTL_TE="$argCustomScriptTTL_TE" && vbm "Custom scriptTTL_TE from -B:$scriptTTL_TE";
-       else
-           ### F: argcustomScriptTTL is not a time element
-           yell "ERROR:Invalid time element argument for custom script time-to-live."; showUsage; exit 1;
-       fi;
-       ## F: do not change scriptTTL_TE
-    fi;    
-} # Sets custom script or buffer TTL if specified
 magicSetScriptTTL() {
     #Desc: Sets script_TTL seconds from provided time_element string argument
     #Usage: magicSetScriptTTL [str time_element]
@@ -623,22 +911,6 @@ magicSetScriptTTL() {
        yell "ERROR:Invalid argument for setScriptTTL function:$argTimeElement"; exit 1;
     fi;
 } # Set scriptTTL in seconds until next (day|hour).
-magicInitCheckTar() {
-    # Desc: Initializes or checks output tar
-    # input: vars: dirOut, bufferTTL, cmd_encrypt_suffix, cmd_compress_suffix
-    # input: vars: scriptHostname
-    # output: vars: pathout_tar
-    # depends: Bash 5.0.3, vbm(), dateShort(), checkMakeTar(), magicWriteVersion()
-
-    # Form pathout_tar
-    pathout_tar="$dirOut"/"$(dateShort "$(date --date="$bufferTTL seconds ago" --iso-8601=seconds)")".."$scriptHostname""$label""$cmd_compress_suffix""$cmd_encrypt_suffix".tar && \
-       vbm "STATUS:Set pathout_tar to:$pathout_tar";
-    # Validate pathout_tar as tar.
-    checkMakeTar "$pathout_tar";
-    ## Add VERSION file if checkMakeTar had to create a tar (exited 1) or replace one (exited 2)
-    vbm "exit status before magicWriteVersion:$?"
-    if [[ $? -eq 1 ]] || [[ $? -eq 2 ]]; then magicWriteVersion; fi    
-} # Initialize tar, set pathout_tar
 magicWriteVersion() {
     # Desc: Appends time-stamped VERSION to pathout_tar
     # Usage: magicWriteVersion
@@ -672,86 +944,6 @@ magicWriteVersion() {
     # Write contentVersion as file fileoutVersion and write-append to pathout_tar
     appendArgTar "$contentVersion" "$fileoutVersion" "$pathout_tar" "$dir_tmp";
 } # write version data to pathout_tar via appendArgTar()
-magicParseProcessStrings() {
-    # Desc: Processes user-supplied process strings into process commands for appendFileTar().
-    # Usage: magicParseProcessStrings
-    # In : vars: optionProcString optionNoStoreRaw optionStoreRaw argRawFileExt
-    #      arry: argProcStrings, argProcFileExts
-    # Out: arry: procStrings, procFileExts
-    # Depends Bash 5.0.3, yell(), vbm()
-    local rawFileExt
-
-    vbm "STATUS:Starting magicParseProcessStrings() function.";
-    # Validate input
-    ## Validate argRawFileExt
-    if [[ "$argRawFileExt" =~ ^[.][[:alnum:]]*$ ]]; then
-       rawFileExt="$argRawFileExt";
-    fi;
-    
-    # Add default stdin output file entries for procStrings, procFileExts
-    ## Check if user specified that no raw stdin be saved.
-    if [[ ! "$optionNoStoreRaw" = "true" ]]; then
-       ### T: --no-store-raw not set. Store raw. Append procStrings with cat.
-       #### Append procStrings array
-       procStrings+=("cat ");
-       #### Check if --store-raw set.
-       if [[ "$optionStoreRaw" = "true" ]]; then
-           ##### T: --store-raw set. Append procFileExts with user-specified file ext
-           procFileExts+=("$rawFileExt");
-       else
-           ##### F: --store-raw not set. Append procFileExts with default ".stdin" file ext
-           ###### Append procFileExts array
-           procFileExts+=(".stdin");
-       fi;
-    else
-       ### F: --no-store-raw set. Do not store raw.
-       #### Do not append procStrings or procFileExts arrays.
-       :
-    fi;
-
-    # Do nothing more if optionProcString not set to true.
-    if [[ ! "$optionProcString" = "true" ]]; then
-       vbm "STATUS:optionProcString not set to 'true'. Returning early.";
-       return; fi;
-    # Validate input array indices
-    ## Make sure that argProcStrings and argProcFileExts have same index counts
-    if ! [[ "${#argProcStrings[@]}" -eq "${#argProcFileExts[@]}" ]]; then
-       yell "ERROR:Mismatch in number of elements in arrays argProcStrings and argProcFileExts:${#argProcStrings[@]} DNE ${#argProcFileExts[@]}";
-       yell "argProcStrings:${argProcStrings[*]}"; yell "argProcFileExts:${argProcFileExts[*]}"; exit 1; fi;
-    ## Make sure that no array elements are blank
-    for element in "${argProcStrings[@]}"; do
-       if [[ -z "$element" ]]; then yell "ERROR:Empty process string specified. Exiting."; exit 1; fi; done
-    for element in "${argProcFileExts[@]}"; do
-       if [[ -z "$element" ]]; then yell "ERROR:Empty output file extension specified. Exiting."; exit 1; fi; done
-    ## Make sure that no process string starts with '-' (ex: if only one arg supplied after '-p' option)
-    for element in "${argProcStrings[@]}"; do
-       if [[ ! "$element" =~ ^[-][[:print:]]*$ ]] && [[ "$element" =~ ^[[:print:]]*$ ]]; then
-           yell "ERROR:Illegal character '-' at start of process string element. Option syntax error?";
-           exit 1; fi; done;
-    vbm "STATUS:Quick check shows argProcStrings and argProcFileExts appear to have valid contents.";
-    procStrings=("${argProcStrings[@]}"); # Export process command strings
-    procFileExts=("${argProcFileExts[@]}"); # Export process command strings
-    vbm "STATUS:Finished magicParseProcessStrings() function.";
-} # Validate and save process strings and file extensions to arrays procStrings, procFileExts
-magicParseLabel() {
-    # Desc: Parses -l option to set label
-    # In : optionLabel, argLabel
-    # Out: vars: label
-    # Depends: Bash 5.0.3, vbm(), yell()
-    
-    vbm "STATUS:Started magicParseLabel() function.";
-    # Do nothing if optionLabel not set to true.
-    if [[ ! "$optionLabel" = "true" ]]; then
-       vbm "STATUS:optionlabel not set to 'true'. Returning early.";
-       return;
-    fi;
-    # Set label if optionLabel is true
-    if [[ "$optionLabel" = "true" ]]; then
-       label="_""$argLabel";
-       vbm "STATUS:Set label:$label";
-    fi;
-    vbm "STATUS:Finished magicParseLabel() function.";
-}
 magicProcessWriteBuffer() {
     # Desc: process and write buffer
     # In : vars: bufferTTL bufferTTL_STR scriptHostname label dir_tmp SECONDS
@@ -817,6 +1009,7 @@ magicProcessWriteBuffer() {
     
     vbm "DEBUG:STATUS:$fn:Finished magicProcessWriteBuffer().";
 } # Process and Write buffer
+
 main() {
     # Process arguments
     processArguments "$@";